unit Index;

interface

uses
  Classes, Structures;

type
  TIndex = class (TObject)
  private
    FHandle : Integer;
    FLookup : Integer;
    FSize : Integer;
    FTag : Integer;
    FSource : Integer;
  public
    property Handle : Integer read FHandle write FHandle;
    property Lookup : Integer read FLookup write FLookup;
    property Size : Integer read FSize write FSize;
    property Tag : Integer read FTag write FTag;
    property Source : Integer read FSource write FSource;
  end;

  TIndexList = class (TIndexedList)
  private
    procedure DoDelete(Sender : TObject; Data : TObject);
  protected
    function GetItems(Index : Integer) : TObject;
  public
    constructor Create;
    procedure Add(AHandle, ALookup, ASize, ATag, ASource : Integer);
    property Items[Index : Integer] : TObject read GetItems; default;
  end;

implementation

uses
  SysUtils;

constructor TIndexList.Create;
begin
  inherited Create;
  OnDelete := DoDelete;
end;

procedure TIndexList.DoDelete(Sender : TObject; Data : TObject);
begin
  Data.Free;
end;

procedure TIndexList.Add(AHandle, ALookup, ASize, ATag, ASource : Integer);
var
  I : TIndex;
begin
   // Remove any old instances
  GotoBeginning;
  while not EndOfList and (TIndexedNode(GetNode).Index < AHandle) do
    Next;
  if not EndOfList and (TIndexedNode(GetNode).Index = AHandle) then
    Delete;

   // Add the new one
  I := TIndex.Create;
  I.Handle := AHandle;
  I.Lookup := ALookup;
  I.Size := ASize;
  I.Tag := ATag;
  I.Source := ASource;
  inherited Add(I, AHandle);
end;

function TIndexList.GetItems(Index : Integer) : TObject;
begin
   // Remove any old instances
  GotoBeginning;
  while Index > 0 do
    begin
      Next;
      Dec(Index);
    end;

  Result := TIndexedNode(GetNode).Data;
{
  while not EndOfList and (TIndexedNode(GetNode).Index < Index) do
    Next;
  if not EndOfList and (TIndexedNode(GetNode).Index = Index) then
    Result := TIndexedNode(GetNode).Data
  else
    raise Exception.Create('Index not found');
}
end;

end.
