unit UOGumps;

interface

uses
  Classes, Graphics, SysUtils;

type
{$A-}
  TGumpIndex = Record
    Lookup,
    Length : Integer;
    Height,
    Width : Word;
  end;
{$A+}

procedure DrawGumpToBitmap(Stream : TStream; ALookup, ALength : Integer;
                           AWidth, AHeight : Word; Bitmap : TBitmap);

implementation

type
  TIntegerArray = Array[0..0] of Integer;
  PIntegerArray = ^TIntegerArray;

procedure DrawGumpToBitmap(Stream : TStream; ALookup, ALength : Integer;
                           AWidth, AHeight : Word; Bitmap : TBitmap);
var
  X, Y, I, J, Size : Integer;
  LookupList : PIntegerArray;
  DataStart : Integer;
{$A-}
  Buffer : Array[0..1024] of Record Value, Run : Word; end;
{$A+}
begin
  Stream.Seek(ALookup, soFromBeginning);
  with Bitmap do
    begin
      Transparent := False;
      PixelFormat := pf15bit;
      Width := AWidth;
      Height := AHeight;
    end;

  GetMem(LookupList, AHeight*4);
  try
    DataStart := Stream.Position;
    Stream.Read(LookupList^, AHeight*4);

    Y := 0;
    While (Y < AHeight) do
      begin
        If Y < AHeight-1 then
          Size := LookupList^[Y+1]-LookupList^[Y]
        else
          Size := ALength div 4 - LookupList^[Y];

        Stream.Seek(DataStart + LookupList^[Y] * 4, soFromBeginning);

        X := 0;
        Stream.Read(Buffer, Size*4);
        For I := 0 to Size-1 do
          begin
            J := X+Buffer[I].Run;
            while X < J do
              begin
                PWordArray(Bitmap.ScanLine[Y])^[X] := Buffer[I].Value;
                Inc(X);
              end;
          end;
        Inc(Y);
      end;
  finally
    FreeMem(LookupList, AHeight*4);
  end;

  Bitmap.TransparentColor := 0;
  Bitmap.TransparentMode := tmFixed;
  Bitmap.Transparent := True;
end;

end.
